/* I[vAhX@ɂnbVi\[Xj*/

#include <stdio.h>
#include <stdlib.h>
#include "Member.h"
#include "ClosedHash.h"

/*--- nbV֐ikeỹnbVlԂj ---*/
static int hash(int key, int size)
{
	return key % size;
}

/*--- ănbV֐ ---*/
static int rehash(int key, int size)
{
	return (key + 1) % size;
}

/*--- m[h̊eoɒlݒ ----*/
static void SetBucket(Bucket *n, const Member *x, Status stat)
{
	n->data = *x;		/* f[^ */
	n->stat = stat;		/* vf̏ */
}

/*--- nbV\ ---*/
int Initialize(ClosedHash *h, int size)
{
	int i;

	if ((h->table = calloc(size, sizeof(Bucket))) == NULL) {
		h->size = 0;
		return 0;
	}

	h->size = size;
	for (i = 0; i < size; i++)			/* ׂẴoPbg */
		h->table[i].stat = Empty;		/* ɂ */
	return 1;
}

/*--- T ---*/
Bucket *Search(const ClosedHash *h, const Member *x)
{
	int i;
	int key = hash(x->no, h->size);		/* Tf[^̃nbVl */
	Bucket *p = &h->table[key];			/* ڃm[h */

	for (i = 0; p->stat != Empty && i < h->size; i++) {
		if (p->stat == Occupied && p->data.no == x->no)
			return p;
		key = rehash(key, h->size);		/* ănbV */
		p = &h->table[key];
	}
	return NULL;
}

/*--- f[^̒ǉ ---*/
int Add(ClosedHash *h, const Member *x)
{
	int i;
	int key = hash(x->no, h->size);		/* ǉf[^̃nbVl */
	Bucket *p = &h->table[key];			/* ڃm[h */

	if (Search(h, x))					/* ̃L[͓o^ */
		return 1;

	for (i = 0; i < h->size; i++) {
		if (p->stat == Empty || p->stat == Deleted) {
			SetBucket(p, x, Occupied);
			return 0;
		}
		key = rehash(key, h->size);		/* ănbV */
		p = &h->table[key];
	}
	return 2;							/* nbV\t */
}

/*--- f[^̍폜 ---*/
int Remove(ClosedHash *h, const Member *x)
{
	Bucket *p = Search(h, x);

	if (p == NULL)
		return 1;						/* ̃L[l݂͑Ȃ */

	p->stat = Deleted;
	return 0;
}

/*--- nbV\_v ---*/
void Dump(const ClosedHash *h)
{
	int i;

	for (i = 0; i < h->size; i++) {
		printf("%02d : ", i);
		switch (h->table[i].stat) {
		case Occupied: printf("%d (%s)\n",
			h->table[i].data.no, h->table[i].data.name);
			break;

		case Empty:	 printf("-- o^ --\n");  break;

		case Deleted:	 printf("-- 폜 --\n");  break;
		}
	}
}

/*--- Sf[^̍폜 ---*/
void Clear(ClosedHash *h)
{
	int i;
	for (i = 0; i < h->size; i++)	/* ׂẴoPbg */
		h->table[i].stat = Empty;	/* ɂ */
}

/*--- nbV\n ---*/
void Terminate(ClosedHash *h)
{
	Clear(h);				/* Sf[^폜 */
	free(h->table);			/* nbV\pz̋L */
	h->size = 0;			/* nbV\̗eʂNA */
}
